#include "../headers/etc/StaticData.h"
#include "../headers/etc/Parameter.h"
#include "../headers/etc/Typedef.h"
#include "../headers/etc/Utility.h"

#include "../headers/DataStructure/Phrase.h"

#include "../headers/Model/LanguageModel.h"

void Phrase::set(const string& phrase){
  // t[YPɕ
  StringArray words = split(strip(phrase));

  // P̏
  if(!wordIDArray.empty())   wordIDArray.clear();
  wordIDArray.reserve(words.size());

  // P̖|󃂃fIDƌꃂfIDۑ
  for(StringArray::const_iterator it = words.begin(); it != words.end(); it++){
    WordID currentID = &(*wordDic.insert( (*it) ).first);   // insertς݂Ȃ΂̃GgԂ
    wordIDArray.push_back(currentID);
  }
  if(language == SRC) return;

  // ړIt[YȂ΁AꃂfID擾
  if(!lmWordIDArray.empty()) lmWordIDArray.clear();
  lmWordIDArray.reserve(words.size());
  for(WordIDArray::reverse_iterator it = wordIDArray.rbegin(); it != wordIDArray.rend(); it++){
    lmWordIDArray.push_back( StaticData::getInstance().getLanguageModel().getID(**it) );
  }
}

const unsigned Phrase::size() const {
  if(wordIDArray.size() != lmWordIDArray.size() && language == TGT){
    cerr << "Error: phrase \"";
    cerr << (*this);
    cerr << "\" has different length id array(TM-LM = ";
    cerr << wordIDArray.size() << "-" << lmWordIDArray.size() << ")" << endl;
    exit(1);
  }
  return wordIDArray.size();
}

// staticϐ̏
const  unsigned Phrase::phraseLengthMax = 7;
WordDic   Phrase::wordDic;
