#include "../headers/etc/StaticData.h"
#include "../headers/etc/Parameter.h"

#include "../headers/Model/LanguageModel.h"
#include "../headers/Model/PhraseTable.h"

StaticData::~StaticData(){
  delete ptLanguageModel;
  delete ptParameter;
  delete ptPhraseTable;
}

void StaticData::initialize(const int argc, const char** argv){
  const Parameter& param = (ptParameter==NULL) ? *Parameter::readArgs(argc, argv) : getParameter();
  setParameter(param);
  if(ptLanguageModel == NULL){
    LanguageModel* ptLanguageModel = new LanguageModel(param.getNGramOrder(), param.getLMFileName());
    setLanguageModel(*ptLanguageModel);
  }
  if(ptPhraseTable == NULL){
    PhraseTable* phraseTable = new PhraseTable(param, *ptLanguageModel);
    setPhraseTable(*phraseTable);
  }
}

StaticData*    StaticData::ptStaticData    = new StaticData();
