#ifndef OBJECTPOOL_H_
#define OBJECTPOOL_H_

template <class T> class FixedObjectPool{
private:
  const unsigned capacity;
  T* pool;
  T* top;

public:
  FixedObjectPool() : capacity(1000*1000U){
    pool = new T[capacity];
    clear();
  }

  void clear(){
    pool[0].setPrev(NULL);
    for(unsigned i=1; i<capacity; i++)
      pool[i].setPrev(&pool[i-1]);
    top = &pool[capacity-1];
  }

  T* pop(){
    T* retVal = top;
    if(top == NULL){
      cerr << "No more Object in pool!!" << endl;
      exit(1);
    }
    top = top->getPrev();

    return retVal;
  }

  // const T* top() const { return top; }

  void push(T* object){
    object->setPrev(top);
    top = object;
  }
};

#endif /* OBJECTPOOL_H_ */
