#ifndef _PHRASE_
#define _PHRASE_

#include <vector>
#include <string>
#include <set>
#include <sstream>
#include <valarray>

#include "../etc/Typedef.h"

using namespace std;

class Phrase {
 // static member
 public:
  const static unsigned phraseLengthMax;
  static const unsigned getWordDicSize(){
    return wordDic.size();
  }

 private:
  static WordDic wordDic;

 // member variable
 protected:
  bool          language;
  WordIDArray   wordIDArray;
  LMWordIDArray lmWordIDArray;

 public:
  explicit Phrase(const string& phrase="", const bool language=TGT) : language(language)
  { set(phrase); }

  // Sentence畔ƂɎgp
  explicit Phrase(const WordIDArray& wordIDArray, const LMWordIDArray& lmWordIDArray = LMWordIDArray(), const bool language = SRC)
   : wordIDArray(wordIDArray), lmWordIDArray(lmWordIDArray), language(language)
   {};

  void set(const string& phrase);

  bool operator==(const Phrase& rhs) const {
    return wordIDArray == rhs.getWordIDArray();

    // return (wordIDArray == rhs.getWordIDArray() && lmWordIDArray == rhs.getLMWordIDArray() );
  }

  const WordIDArray& getWordIDArray() const {
    return wordIDArray;
  }

  const LMWordIDArray& getLMWordIDArray() const {
    return lmWordIDArray;
  }

  const unsigned size() const;

  string toString() const {
    string phrase;
    for(unsigned i=0; i<wordIDArray.size(); i++)
      phrase += (*wordIDArray.at(i)) + " ";
    return phrase;
  }

  bool operator<(const Phrase& rhs) const {
    return wordIDArray < rhs.getWordIDArray();
  }

  int copyLMWordID(LMWordID* buffer) const {
    copy(lmWordIDArray.begin(), lmWordIDArray.end(), buffer);
    return (int)lmWordIDArray.size();
  }
};

static ostream& operator<<(ostream& os, const Phrase& rhs) {
  return os << rhs.toString();
}

#endif
