#ifndef _STATIC_DATA_
#define _STATIC_DATA_

#include <iostream>

using namespace std;

class Parameter;
class LanguageModel;
class PhraseTable;

class StaticData{
 private:
  const Parameter*     ptParameter;
  LanguageModel* ptLanguageModel;
  const PhraseTable*   ptPhraseTable;
  static StaticData*   ptStaticData;

 private:
  StaticData()
    : ptLanguageModel(NULL), ptPhraseTable(NULL), ptParameter(NULL)
    {}

  ~StaticData();

  void setLanguageModel(LanguageModel& languageModel) {
    ptLanguageModel = &languageModel;
  }
  void setPhraseTable(const PhraseTable& phraseTable) {
    ptPhraseTable = &phraseTable;
  }
  void setParameter(const Parameter& parameter) {
    ptParameter = &parameter;
  }

 public:
  static void allocInstance(){
    if(ptStaticData==NULL)
      ptStaticData = new StaticData();
  }

  static void deleteInstance(){
    if(ptStaticData!=NULL){
      delete ptStaticData;
      ptStaticData = NULL;
    }
  }

  // getter
  static  StaticData&    getInstance() { return *ptStaticData; }

  LanguageModel& getLanguageModel() { return *ptLanguageModel; }
  const PhraseTable&   getPhraseTable()   const { return *ptPhraseTable; }
  const Parameter&     getParameter()     const { return *ptParameter; }

  // setter
                 void          initialize(const int argc, const char** argv);
};

#endif
